/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/DataArrayResponse.h>
#include <activemq/exceptions/NullPointerException.h>

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for DataArrayResponse
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
DataArrayResponse::DataArrayResponse()
{
}

////////////////////////////////////////////////////////////////////////////////
DataArrayResponse::~DataArrayResponse()
{
    for( size_t idata = 0; idata < data.size(); ++idata ) {
        delete data[idata];
    }
}

////////////////////////////////////////////////////////////////////////////////
DataStructure* DataArrayResponse::cloneDataStructure() const {
    DataArrayResponse* dataArrayResponse = new DataArrayResponse();

    // Copy the data from the base class or classes
    dataArrayResponse->copyDataStructure( this );

    return dataArrayResponse;
}

////////////////////////////////////////////////////////////////////////////////
void DataArrayResponse::copyDataStructure( const DataStructure* src ) {

    // Copy the data of the base class or classes
    Response::copyDataStructure( src );

    const DataArrayResponse* srcPtr = dynamic_cast<const DataArrayResponse*>( src );

    if( srcPtr == NULL || src == NULL ) {
    
        throw exceptions::NullPointerException(
            __FILE__, __LINE__,
            "DataArrayResponse::copyDataStructure - src is NULL or invalid" );
    }
    for( size_t idata = 0; idata < srcPtr->getData().size(); ++idata ) {
        this->getData().push_back( 
            dynamic_cast<DataStructure*>( 
                srcPtr->getData()[idata]->cloneDataStructure() ) );
    }
}

////////////////////////////////////////////////////////////////////////////////
unsigned char DataArrayResponse::getDataStructureType() const {
    return DataArrayResponse::ID_DATAARRAYRESPONSE; 
}

////////////////////////////////////////////////////////////////////////////////
const std::vector<DataStructure*> DataArrayResponse::getData() const {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
std::vector<DataStructure*> DataArrayResponse::getData() {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
void DataArrayResponse::setData(std::vector<DataStructure*> data ) {
    this->data = data;
}

