/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/PartialCommand.h>
#include <activemq/exceptions/NullPointerException.h>

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for PartialCommand
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
PartialCommand::PartialCommand()
{
    this->commandId = 0;
}

////////////////////////////////////////////////////////////////////////////////
PartialCommand::~PartialCommand()
{
}

////////////////////////////////////////////////////////////////////////////////
DataStructure* PartialCommand::cloneDataStructure() const {
    PartialCommand* partialCommand = new PartialCommand();

    // Copy the data from the base class or classes
    partialCommand->copyDataStructure( this );

    return partialCommand;
}

////////////////////////////////////////////////////////////////////////////////
void PartialCommand::copyDataStructure( const DataStructure* src ) {

    // Copy the data of the base class or classes
    BaseDataStructure::copyDataStructure( src );

    const PartialCommand* srcPtr = dynamic_cast<const PartialCommand*>( src );

    if( srcPtr == NULL || src == NULL ) {
    
        throw exceptions::NullPointerException(
            __FILE__, __LINE__,
            "PartialCommand::copyDataStructure - src is NULL or invalid" );
    }
    this->setCommandId( srcPtr->getCommandId() );
    this->setData( srcPtr->getData() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char PartialCommand::getDataStructureType() const {
    return PartialCommand::ID_PARTIALCOMMAND; 
}

////////////////////////////////////////////////////////////////////////////////
const int PartialCommand::getCommandId() const {
    return commandId;
}

////////////////////////////////////////////////////////////////////////////////
int PartialCommand::getCommandId() {
    return commandId;
}

////////////////////////////////////////////////////////////////////////////////
void PartialCommand::setCommandId(int commandId ) {
    this->commandId = commandId;
}

////////////////////////////////////////////////////////////////////////////////
const std::vector<unsigned char> PartialCommand::getData() const {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
std::vector<unsigned char> PartialCommand::getData() {
    return data;
}

////////////////////////////////////////////////////////////////////////////////
void PartialCommand::setData(std::vector<unsigned char> data ) {
    this->data = data;
}

