/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/SessionId.h>
#include <activemq/exceptions/NullPointerException.h>

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for SessionId
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
SessionId::SessionId()
{
    this->connectionId = "";
    this->value = 0;
}

////////////////////////////////////////////////////////////////////////////////
SessionId::~SessionId()
{
}

////////////////////////////////////////////////////////////////////////////////
DataStructure* SessionId::cloneDataStructure() const {
    SessionId* sessionId = new SessionId();

    // Copy the data from the base class or classes
    sessionId->copyDataStructure( this );

    return sessionId;
}

////////////////////////////////////////////////////////////////////////////////
void SessionId::copyDataStructure( const DataStructure* src ) {

    // Copy the data of the base class or classes
    BaseDataStructure::copyDataStructure( src );

    const SessionId* srcPtr = dynamic_cast<const SessionId*>( src );

    if( srcPtr == NULL || src == NULL ) {
    
        throw exceptions::NullPointerException(
            __FILE__, __LINE__,
            "SessionId::copyDataStructure - src is NULL or invalid" );
    }
    this->setConnectionId( srcPtr->getConnectionId() );
    this->setValue( srcPtr->getValue() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char SessionId::getDataStructureType() const {
    return SessionId::ID_SESSIONID; 
}

////////////////////////////////////////////////////////////////////////////////
const std::string& SessionId::getConnectionId() const {
    return connectionId;
}

////////////////////////////////////////////////////////////////////////////////
std::string& SessionId::getConnectionId() {
    return connectionId;
}

////////////////////////////////////////////////////////////////////////////////
void SessionId::setConnectionId(const std::string& connectionId ) {
    this->connectionId = connectionId;
}

////////////////////////////////////////////////////////////////////////////////
const long long SessionId::getValue() const {
    return value;
}

////////////////////////////////////////////////////////////////////////////////
long long SessionId::getValue() {
    return value;
}

////////////////////////////////////////////////////////////////////////////////
void SessionId::setValue(long long value ) {
    this->value = value;
}

