/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/ShutdownInfo.h>
#include <activemq/exceptions/NullPointerException.h>

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for ShutdownInfo
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
ShutdownInfo::ShutdownInfo()
{
}

////////////////////////////////////////////////////////////////////////////////
ShutdownInfo::~ShutdownInfo()
{
}

////////////////////////////////////////////////////////////////////////////////
DataStructure* ShutdownInfo::cloneDataStructure() const {
    ShutdownInfo* shutdownInfo = new ShutdownInfo();

    // Copy the data from the base class or classes
    shutdownInfo->copyDataStructure( this );

    return shutdownInfo;
}

////////////////////////////////////////////////////////////////////////////////
void ShutdownInfo::copyDataStructure( const DataStructure* src ) {

    // Copy the data of the base class or classes
    BaseCommand::copyDataStructure( src );

    const ShutdownInfo* srcPtr = dynamic_cast<const ShutdownInfo*>( src );

    if( srcPtr == NULL || src == NULL ) {
    
        throw exceptions::NullPointerException(
            __FILE__, __LINE__,
            "ShutdownInfo::copyDataStructure - src is NULL or invalid" );
    }
}

////////////////////////////////////////////////////////////////////////////////
unsigned char ShutdownInfo::getDataStructureType() const {
    return ShutdownInfo::ID_SHUTDOWNINFO; 
}

