/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/JournalQueueAckMarshaller.h>

#include <activemq/connector/openwire/commands/JournalQueueAck.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::utils;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* JournalQueueAckMarshaller::createObject() const {
    return new JournalQueueAck();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char JournalQueueAckMarshaller::getDataStructureType() const {
    return JournalQueueAck::ID_JOURNALQUEUEACK;
}

///////////////////////////////////////////////////////////////////////////////
void JournalQueueAckMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) throw( io::IOException ){
   BaseDataStreamMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    JournalQueueAck* info =
        dynamic_cast<JournalQueueAck*>( dataStructure );
    info->setDestination( dynamic_cast< ActiveMQDestination* >(
        tightUnmarshalNestedObject( wireFormat, dataIn, bs ) ) );
    info->setMessageAck( dynamic_cast< MessageAck* >(
        tightUnmarshalNestedObject( wireFormat, dataIn, bs ) ) );
}

///////////////////////////////////////////////////////////////////////////////
int JournalQueueAckMarshaller::tightMarshal1( OpenWireFormat* wireFormat, DataStructure* dataStructure, BooleanStream* bs ) throw( io::IOException ){

    JournalQueueAck* info =
        dynamic_cast<JournalQueueAck*>( dataStructure );

    int rc = BaseDataStreamMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    rc += tightMarshalNestedObject1( wireFormat, info->getDestination(), bs );
    rc += tightMarshalNestedObject1( wireFormat, info->getMessageAck(), bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void JournalQueueAckMarshaller::tightMarshal2( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataOutputStream* dataOut, BooleanStream* bs ) throw( io::IOException ){

    BaseDataStreamMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    JournalQueueAck* info =
        dynamic_cast<JournalQueueAck*>( dataStructure );
    tightMarshalNestedObject2( wireFormat, info->getDestination(), dataOut, bs );
    tightMarshalNestedObject2( wireFormat, info->getMessageAck(), dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void JournalQueueAckMarshaller::looseUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn ) throw( io::IOException ){
    BaseDataStreamMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    JournalQueueAck* info = 
        dynamic_cast<JournalQueueAck*>( dataStructure );
    info->setDestination( dynamic_cast< ActiveMQDestination* >( 
        looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
    info->setMessageAck( dynamic_cast< MessageAck* >( 
        looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
}

///////////////////////////////////////////////////////////////////////////////
void JournalQueueAckMarshaller::looseMarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataOutputStream* dataOut ) throw( io::IOException ){
    JournalQueueAck* info =
        dynamic_cast<JournalQueueAck*>( dataStructure );
    BaseDataStreamMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    looseMarshalNestedObject( wireFormat, info->getDestination(), dataOut );
    looseMarshalNestedObject( wireFormat, info->getMessageAck(), dataOut );
}

