/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/RemoveInfoMarshaller.h>

#include <activemq/connector/openwire/commands/RemoveInfo.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::utils;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* RemoveInfoMarshaller::createObject() const {
    return new RemoveInfo();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char RemoveInfoMarshaller::getDataStructureType() const {
    return RemoveInfo::ID_REMOVEINFO;
}

///////////////////////////////////////////////////////////////////////////////
void RemoveInfoMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) throw( io::IOException ){
   BaseCommandMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    RemoveInfo* info =
        dynamic_cast<RemoveInfo*>( dataStructure );
    info->setObjectId( dynamic_cast< DataStructure* >(
        tightUnmarshalCachedObject( wireFormat, dataIn, bs ) ) );
}

///////////////////////////////////////////////////////////////////////////////
int RemoveInfoMarshaller::tightMarshal1( OpenWireFormat* wireFormat, DataStructure* dataStructure, BooleanStream* bs ) throw( io::IOException ){

    RemoveInfo* info =
        dynamic_cast<RemoveInfo*>( dataStructure );

    int rc = BaseCommandMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    rc += tightMarshalCachedObject1( wireFormat, info->getObjectId(), bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void RemoveInfoMarshaller::tightMarshal2( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataOutputStream* dataOut, BooleanStream* bs ) throw( io::IOException ){

    BaseCommandMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    RemoveInfo* info =
        dynamic_cast<RemoveInfo*>( dataStructure );
    tightMarshalCachedObject2( wireFormat, info->getObjectId(), dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void RemoveInfoMarshaller::looseUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn ) throw( io::IOException ){
    BaseCommandMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    RemoveInfo* info = 
        dynamic_cast<RemoveInfo*>( dataStructure );
    info->setObjectId( dynamic_cast< DataStructure* >( 
        looseUnmarshalCachedObject( wireFormat, dataIn ) ) );
}

///////////////////////////////////////////////////////////////////////////////
void RemoveInfoMarshaller::looseMarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataOutputStream* dataOut ) throw( io::IOException ){
    RemoveInfo* info =
        dynamic_cast<RemoveInfo*>( dataStructure );
    BaseCommandMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    looseMarshalCachedObject( wireFormat, info->getObjectId(), dataOut );
}

